import os
import importlib
import importlib.util
import sys


PATHS_ROOT = os.path.dirname(os.path.realpath(__file__))
PATHS_POCS = os.path.join(PATHS_ROOT, "pocs")

def load_string_to_module(module_name):
	try:
		module_file_path = os.path.join(PATHS_POCS,module_name)
		module_name = module_name
		module_spec = importlib.util.spec_from_file_location(module_name ,module_file_path)
		module = importlib.util.module_from_spec(module_spec)
		module_spec.loader.exec_module(module)
		return module
	except:
		print("load module '{0}' failed!".format(module_name))
		sys.exit()