import sys
from loader import *


class OneUrl():
	def __init__(self,url,script,mode):
		self.url = url
		self.script = script
		self.mode = mode

	def oneUrl(self):
		try:
			module = load_string_to_module(self.script)
			url = self.checkUrl(self.url)
		except AttributeError:
			print("ERROR : 'NoneType' object has no attribute 'loader'")
			sys.exit()
		try:
			if self.mode:
				func = "module."+self.mode+"(\""+url+"\")"
				eval(func)
			else:
				print("Warning : Determine whether the test module is selected")
		except AttributeError:
			print("ERROR : module '{}' has no attribute '{}'".format(self.script,self.mode))
			sys.exit()
	def checkUrl(self,url):
		if ('http://' in url) or ('https://' in url):
			return url
		else:
			url = 'http://'+url
			return url
	def main(self):
		self.oneUrl()
