import requests
import json
import time
import sys
import concurrent.futures
from loader import *



class Zoomeye():
	def __init__(self,app,script,page,mode,threads):
		self.app = app
		self.script = script
		self.page = page
		self.mode = mode
		self.threads = threads
		self.urls = []
		self.headers = {"Authorization":"0"}
	def new_token(self):
		try:
			data = '{"username": "xxxxxxxxxxxxx", "password": "xxxxxxxxxxxxx"}'
			resp = requests.post('https://api.zoomeye.org/user/login', data=data,timeout=5)
			token_dict = json.loads(resp.text)
			token = "JWT %s" % token_dict['access_token']
			self.headers['Authorization'] = token
		except:
			print("Zoomeye authentication error")
			sys.exit()
	def search(self):
		try:
			for i in range(1,self.page):
				url = "https://api.zoomeye.org/web/search?query={}&page={}&facet=app,os".format(self.app,self.page)
				resp = requests.get(url,headers=self.headers)
				data = json.loads(resp.text)
				for match in data["matches"]:
					ans = match["ip"]
					self.urls.append(ans[0])
		except:
			print("Zoomeye gets IP errors")
			sys.exit()
	def pool(self):
		try:
			with concurrent.futures.ThreadPoolExecutor(max_workers=self.threads) as executor:
				executor.map(self.call_back, self.urls)
		except:
			print("threads pool error")
			sys.exit()
	def call_back(self,url):
		try:
			module = load_string_to_module(self.script)
			func = "module."+self.mode+"(\""+url+"\")"
			eval(func)
		except:
			print("Error with callback function")
			sys.exit()
	def main(self):
		self.new_token()
		self.search()
		self.pool()
		
		
		
		
		
		
		
		
		
		
		
		